'''
Started on: 2011.07.20
Last update: nil
Author: Kulverstukas && Factionwars

=================================================
Copyright 2011 Kulverstukas, Factionwars

    This file is part of D0xBase.

    D0xBase is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation version 3

    D0xBase is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with D0xBase.  If not, see http://www.gnu.org/licenses/
=================================================

Shouts: Evilzone.org
You can contact us at: Factionstukas@evilzone.org
--------
Description:
  This module is part of "D0xBase" project.
  Any modification without knowing what you are doing will result
  in unwanted behavior and can stop working.
--------
'''

class Db:

#============================================
    def __init__(self, dbname):
        import sqlite3
        global conn
        conn =  sqlite3.connect(dbname)
        global curs
        curs = conn.cursor()
#============================================
#Here we add the tables to the database
    def install(self):
            curs.execute('''create table person
                           (id integer primary key, name text, lastname text,
                           nickname text, gender text, datebirth text,
                           placebirth text, datedeath text, placedeath text,
                           location text, email text, education text,
                           ocupation text, workplace text, contact text,
                           notes text, date text)''')
#and here we add an example person you can delete this from ->
            curs.execute("""insert into person
                            values (1, 'Captain', 'Obvious', 'Captain-Obvious', 'Unknown',
                            '1960.02.10', 'Internets', 'Not filled', 'Not filled',
                            'Evilzone', 'Captain@Obviousness.com', 'School of Obviousness', 'Captain of the Obvious',
                            'The obvious docks', 'LOL nothing here...', 'workles motherfucker',
                            '2011.07.20')""")
#<- till here
            conn.commit();
#============================================
    def connect(self):
        #Here we try some statements and see if the database
        #is already filled with tables
        try:
           curs.execute("select id from person")
        except Exception:
            self.install()
        curs.execute("select * from person")
        persons = 0
        for row in curs:
           persons = persons + 1
        return persons
#============================================
    def getperson(self, id):
        #id == row id, and it return a list:)
        import sqlite3
        conn.row_factory = sqlite3.Row
        for person in curs.execute('select * from person where id=:id',
        {"id" : id}):
            return list(person)
#============================================
    def addperson(self, List):
        #We calculate the last id but counting all the records in the database
        try:
            curs.execute("select * from person")
            persons = 0
            for row in curs:
               persons += 1
            ID = persons + 1
            curs.execute("insert into person values(:id, :name, :lastname,\
            :nickname, :gender, :datebirth, :placebirth, :datedeath, :placedeath,\
            :location, :email, :education, :ocupation, :workplace, :contact, :note,\
            :date)",
            {"id" : ID, "name" : List[0], "lastname" : List[1],
            "nickname" : List[2], "gender" : List[3], "datebirth" : List[4],
            "placebirth" : List[5],"datedeath" : List[6], "placedeath" : List[7],
            "location" : List[8], "email" : List[9], "education" : List[10],
            "ocupation" : List[11], "workplace" : List[12],  "contact" : List[13],
            "note" : List[14], "date" : List[15]})
            conn.commit()
        except:
            raise Exception('\n\nCannot add. Database seems to be locked. Someone else uses it?\n')
#============================================
    def editperson(self, List):
        try:
            curs.execute("replace into person values(:id, :name, :lastname,\
            :nickname, :gender, :datebirth, :placebirth, :datedeath, :placedeath,\
            :location, :email, :education, :ocupation, :workplace, :contact, :note,\
            :date)",
            {"id" : List[0], "name" : List[1], "lastname" : List[2],
            "nickname" : List[3], "gender" : List[4], "datebirth" : List[5],
            "placebirth" : List[6],"datedeath" : List[7], "placedeath" : List[8],
            "location" : List[9], "email" : List[10], "education" : List[11],
            "ocupation" : List[12], "workplace" : List[13],  "contact" : List[14],
            "note" : List[15], "date" : List[16]})
            conn.commit()
        except:
            raise Exception('\n\nCannot edit. Database seems to be locked. Someone else uses it?\n')
#============================================
    def deleteperson(self, id):
        try:
            curs.execute("delete from person where id=:id",
            {"id" : id})
            conn.commit()
        except:
            raise Exception('\n\nCannot delete. Database seems to be locked. Someone else uses it?\n')
#============================================
    def search(self, column, statement):
        import sqlite3
        conn.row_factory = sqlite3.Row
        sql='select id from person where '+column+' like ?'
        curs.execute(sql,('%'+statement+'%',))
        idlist = curs.fetchall()
        return list(idlist)
#============================================
#example usage:)
'''
database = Db('dox')
print 'number of records'
print database.connect()
print database.getperson(1)[1:]
print database.search('name', 'cap')
''
'''
